diff -Naur nagios-plugins-trunk-200807311200/plugins/check_http.c nagios-plugins-trunk-200807311200-new/plugins/check_http.c
--- nagios-plugins-trunk-200807311200/plugins/check_http.c	2008-05-30 17:38:00.000000000 -0600
+++ nagios-plugins-trunk-200807311200-new/plugins/check_http.c	2008-07-31 12:16:13.000000000 -0600
@@ -748,16 +748,18 @@
     }
   }
 #endif /* HAVE_SSL */
-
-  asprintf (&buf, "%s %s HTTP/1.0\r\n%s\r\n", http_method, server_url, user_agent);
-
+  
+  /* If a hostname is provided, use HTTP/1.1 and send the hostname before the 
+  *  Useragent. This fixes an issue with getting 301 responses from servers
+  *  with virtual hosts */
+  if(host_name)
+    asprintf (&buf, "%s %s HTTP/1.1\r\nHost: %s\r\n%s\r\n", http_method, server_url, host_name, user_agent);
+  
+  else
+    asprintf (&buf, "%s %s HTTP/1.0\r\n%s\r\n", http_method, server_url, user_agent);
   /* tell HTTP/1.1 servers not to keep the connection alive */
   asprintf (&buf, "%sConnection: close\r\n", buf);
 
-  /* optionally send the host header info */
-  if (host_name)
-    asprintf (&buf, "%sHost: %s:%d\r\n", buf, host_name, server_port);
-
   /* optionally send any other header tag */
   if (http_opt_headers_count) {
     for (i = 0; i < http_opt_headers_count ; i++) {